stm8/
; test.asm     
    TITLE  "test.asm"
    MOTOROLA
  
    #include "STM8S103F3P.inc"

; ********************************************************
    BYTES
    segment byte at 0000 'RAM_0'
    dc.b     $00, $01, $02, $03, $04, $05, $06, $07, $08, $09, $0A, $0B, $0C, $0D, $0E, $0F

; ********************************************************
    WORDS
    segment byte at 0100 'RAM_1'
main_RAM:
   ldw     X, #$03FF               ; [AE 03 FF]
   ldw     SP, X                   ; [94]
; Включаем pull-up на портах (если подтяжка не предусмотрена внешней схемой)
   ld       A, #%11111111          ; [A6 FF]
   ld       PA_CR1, A              ; [C7 50 03]
   ld       PB_CR1, A              ; [C7 50 08]
   ld       PC_CR1, A              ; [C7 50 0D]
   ld       PD_CR1, A              ; [C7 50 12]
; настраиваем UART на прием/передачу на скорости 9600, остальные настройки по умолчанию (8 бит, нет бита четности, 1 стоповый бит)
;  mov    UART1_BRR2, #0            ; [35 00 52 33]  для Fmaster=16/8=2МГц и 9600
   mov    UART1_BRR1, #13           ; [35 0D 52 32]  для Fmaster=16/8=2МГц и 9600
   mov    UART1_CR2, #%00001100     ; [35 0C 52 35]    UART1_CR2.TEN <- 1  UART1_CR2.REN <- 1  разрешаем передачу/прием	
; включаем светодиод	
	bset     PB_DDR,#5 		; 
	bset     PB_CR1,#5 		; 
; отправляем байт по UART
    mov      UART1_DR, #$15          ; [35 13 52 31]
; уходим во FLASH
    jp    main_FLASH
	
; ********************************************************
; 
    WORDS      ; 
    segment byte at 4000 'EEPROM'  
; немного данных в EEPROM
    dc.w     $1111, $2222, $3333, $4444, $5555, $6666, $7777, $8888
    dc.w     $9999, $AAAA, $BBBB, $CCCC, $DDDD, $EEEE, $FFFF, $0000
    dc.w     $0000, $0000, $1111
  
; ********************************************************
    WORDS      ; 
    segment byte at 8080 'FLASH'

main_FLASH:

   ldw     X, #$03FF               ; [AE 03 FF]
   ldw     SP, X                   ; [94]

; Включаем pull-up на портах (если подтяжка не предусмотрена внешней схемой)
   ld       A, #%11111111          ; [A6 FF]
   ld       PA_CR1, A              ; [C7 50 03]
   ld       PB_CR1, A              ; [C7 50 08]
   ld       PC_CR1, A              ; [C7 50 0D]
   ld       PD_CR1, A              ; [C7 50 12]
; настраиваем UART на прием/передачу на скорости 9600, остальные настройки по умолчанию (8 бит, нет бита четности, 1 стоповый бит)
;  mov    UART1_BRR2, #0            ; [35 00 52 33]  для Fmaster=16/8=2МГц и 9600
   mov    UART1_BRR1, #13           ; [35 0D 52 32]  для Fmaster=16/8=2МГц и 9600
   mov    UART1_CR2, #%00001100     ; [35 0C 52 35]    UART1_CR2.TEN <- 1  UART1_CR2.REN <- 1  разрешаем передачу/прием			
	
main_FLASH_cycle:
; включаем светодиод	
	bset 	PB_DDR,#5 		; 
	bset 	PB_CR1,#5 		; 
; отправляем байт по UART
    mov     UART1_DR, #$13          ; [35 12 52 31]
	callr    main_FLASH_dealay
	callr    main_FLASH_dealay
; выключаем светодиод	
	bres 	PB_DDR,#5 		; 
	bres 	PB_CR1,#5 		; 
; отправляем байт по UART
    mov     UART1_DR, #$23          ; [35 12 52 31]
    callr    main_FLASH_dealay
	callr    main_FLASH_dealay
    jra    main_FLASH_cycle
	
main_FLASH_dealay:
   decw     X
   jrne    main_FLASH_dealay
   ret
	
                   ; [00 00] 
  end
; STM8S103F3P6
; STM8	- Product class			STM8 microcontroller
; S		- Family type			standart
; 103	- Sub-family type		access line
; F		- Pin count				20 pins
; 3		- Program memory size	8 Kbytes
; P		- Case type				TSSOP
; 6								-40...+85 C